/******************************************************************************
       File: Arburg_420M_1000_250
       Description: Основной файл.
       Created: 21 ноября 2016
       Last Modifiede: 06 декабря 2016
       Copyright: GNU General Public License
******************************************************************************/

/*
  //TODO: Добавить комментарии.
  //TODO: HMI, сделать сохранение 2 байтов в U16. Невозможно без использования макросов.
  //TODO: HMI, сделать чтение 2 байтов в U16.
  //TODO: HMI, проверить разрядность и органичения на ввод во всех готовых окнах.
*/

/*
  Скетч использует 11 016 байт (4%) памяти устройства. Всего доступно 253 952 байт.
  Глобальные переменные используют 2710 байт (33%) динамической памяти, оставляя 7 220 байт для локальных переменных. Максимум: 8 192 байт.
  Минимальная скорость цикла - 3800
*/

//*******************************  Библиотеки  *******************************//
#include "Arduino.h"

#include "Def.h"

#include "Config.h"

#include "BitsMacros.h"

#include "ModbusVar.h"


#ifdef USE_AVR_UART
	#include "UART.h"
#endif

#include "ModbusRtuSlave.h"

#include "UARTDebug.h"
 
#include "Timer.h"

#include <util/delay.h>
//*******************************  /Библиотеки  ******************************//

//********************** Объявление переменных, констант *********************//
// Массив данных для сети Modbus.
uint16_t modbusData[MODBUS_DATA_COUNT];

Modbus modbusSlave(MODBUS_SLAVE_ADDRESS, MODBUS_UART_PORT, PIN_RS485_RE_DE);

// Переменные для определения максимального времени цикла.
uint32_t timeCycleBegin = 0;
uint32_t timeCycle = 0;
uint32_t timeCycleMax = 0;
//********************** /Объявление переменных, констант ********************//

//****************************** Основные функции ****************************//
/// <summary>
/// Основная функция main.
/// </summary>
int main(void)
{
  init();

#if defined(USBCON)
  USBDevice.attach();
#endif

  setup();

  for (;;)
  {
    loop();
    // В проекте не используется стандартная библиотека Serial.
    //if (serialEventRun) serialEventRun();
  }

  return 0;
}

/// <summary>
/// Настройка при запуске arduino.
/// </summary>
void setup()
{
  // Инициализируем и открываем UART порт для дебага.
  #ifdef DEBUGGING_THROUGH_UART
    #ifndef USE_AVR_UART
      Serial.begin(UART_DEBUG_SPEED);
    #else
      UARTOpen(UART_DEBUG_PORT, UART_DEBUG_SPEED);
    #endif
  #endif

  // Только для теста.
  DEBUG_PRINTLN("Begin");
  // / Только для теста.

  // Иницилизация Modbus RTU Slave.
  modbusSlave.begin(UART_PORT_SPEED);
  // /Иницилизация Modbus RTU Slave.
    
  // Немного подождем, вдруг, что-то не успело инициализировать.
  _delay_ms(1000);

  // Только для теста.
  DEBUG_PRINTLN("Finish");
  // / Только для теста.
}

/// <summary>
/// Основной цикл.
/// </summary>
void loop()
{  
  // Начальное время цикла.
  timeCycleBegin = micros();

  // Проверяем, поступил ли запрос и если поступил даем ответ.
  int8_t modbusError = modbusSlave.poll(modbusData, MODBUS_DATA_COUNT);
  if (modbusError < 7
    && modbusError != 0)
  {
    //DEBUG_PRINTLN(modbusError);  
  }  
  
  // Обновляем данные в регистрах Modbus и в пользовательской программе.
  UpdateModbusData();

  // Определяем скорость работы.
  timeCycle = GetDifferenceULong(timeCycleBegin, micros());
  // Если текущее значение больше, последнего максимального, отображаем его.
  if (timeCycle > timeCycleMax)
  {
    timeCycleMax = timeCycle;

    DEBUG_PRINT("Max - ");
    DEBUG_PRINTLN(timeCycleMax);
  }
}
//****************************** /Основные функции ***************************//

//******************************* Функции Modbus *****************************//
void UpdateModbusData()
{
  // 0 ячейка памяти на HMI (0x1).
  //MC_WRITE_PIN(PIN_LED_DEBUG, MC_GET_BIT(=0], 0));

  // 1 ячейка памяти на HMI (0x2).
  //MC_WRITE_PIN(PIN_LED_DEBUG, MC_GET_BIT(=15], 1));
}
//******************************* /Функции Modbus ****************************//
