/*******************************************************************************
     * File: Config.h
     * Description: Настройка проекта.
     * Created: 21 ноября 2016
     * Last Modifiede: 06 декабря 2016
     * Copyright: GNU General Public License
*******************************************************************************/

/*
//TODO: Добавить комментарии.
*/

#ifndef CONFIG_H_
#define CONFIG_H_

//*************************** Настройки UART *********************************//
// Порт UART.
#define UART_PORT           2       

// Скорость порта UART.
#define UART_PORT_SPEED     115200UL   
//*************************** /Настройки UART ********************************//

//************************** Настройки Modbus ********************************//
// Используем UART AVR.
//#define USE_AVR_UART 

// Номер Serial который используется для передачи данных по MODBUS.
#define MODBUS_UART_PORT            UART_PORT

// Скорость порта UART для MODBUS.
#define MODBUS_UART_SPEED           UART_PORT_SPEED

// Адрес контроллера в сети Modbus.
#define MODBUS_SLAVE_ADDRESS        10  

// Сохраняем массив в EEPROM.
//#define MODBUS_SAVE_TO_EEPROM

// Загружаем массив из EEPROM.
#define MODBUS_LOAD_FROM_EEPROM
//************************** /Настройки Modbus *******************************//

//*****************************  Настройки TWI *******************************//
// Используем TWI AVR.
//#define USE_AVR_TWI

// TWI скорость - 400kHz 
//#define TWI_SPEED                       400000UL    

// TWI скорость - 100kHz
#define TWI_SPEED                       100000UL
//*****************************  /Настройки TWI *****************************//

//******************** Встроенные подтягивающие рез. I2C ********************//
#define TWI_INTERNAL_PULLUPS
//******************* /Встроенные подтягивающие рез. I2C ********************//

//******************************** Тесты ************************************//
// Отладка через UART.
#define DEBUGGING_THROUGH_UART

// Отладка через LED.
//#define LED_DEBUG

// Тест скорости цикла.
//#define DEBUG_SPEED_CYCLE

// Используем LED для отладки.
//#define DEBUG_LED 
//******************************** /Тесты ***********************************//

//************************ Настройки Debug UART *****************************//
#ifdef DEBUGGING_THROUGH_UART
  // Порт UART.
  #define UART_DEBUG_PORT         0    
  
  // Скорость порта UART.
  #define UART_DEBUG_SPEED        115200UL    
#endif        
//************************ /Настройки Debug UART ****************************//

#endif /* CONFIG_H_ */
